#include "m61.hh"
#include <cstdio>
// Active allocation sizes.

int main() {
    void* ptrs[10];
    for (int i = 0; i != 10; ++i) {
        ptrs[i] = malloc(i + 1);
    }
    for (int i = 0; i != 5; ++i) {
        free(ptrs[i]);
    }
    m61_print_statistics();
}

//! alloc count: active          5   total         10   fail        ???
//! alloc size:  active         40   total         55   fail        ???
/* unsigned long in metadata struct. add it to basemalloc size + size of metadata in malloc func. 
use metadata for active total. 
you want to track an allocated size. Store in an unsigned long (which is size 8 bytes). --> size_t (is better). 
void* base_pointer base_malloc(sz + sizeof(size_t)))
-> this base_pointer points to the very front of the allocated memory segment. 
-> goal is to return  the payload pointer? 
-> free takes payload pointer, subtract?

how to get to payload pointer: 
______________________________________________________________________
unsigned long    | payload   
_________________*____________________________________________________
(void*) payload_ptr = (void*)(uintptr_t)base_pointer + sizeof(size_t);
                         // treat like a normal number and then add

(char*) is a pointer when you perform arithmetic on this, it operates on a scale of one byte.
int* dhilan = &dhilan_int 
++dhilan same as dhilan += 1 // this actually increments the address by 4 but the int* by 1 
int[0] ---> int[1]

struct metadata {
    size_t allocated_size;
    size_t padding;
};
(metadata*) metadata_pointer = // this is where you do the math
size_t current_alloc_size = metadata_pointer  ->allocated_size

payload pointer
base malloc pointer is before payload pointer.


base_malloc --> gives us something at the very front of the memeory we have allocated.
void* base_pointer = base_malloc(sz + sizeof(metadata))
struct metadata {
    // example stuff
    int x;
    char y;
    bool freed;
}
-----------------------------------------------------------------
metadata   |     payload
.----------%----------------------------------------------------

metadata* my_metadata = (metadata*) base_pointer;
// -> 
// * dereference
// . gets at a structure's members

(*my_metadata).x = 5 is the same as lines 67-69
my_metadata->x = 5;
my_metadata->y = 55;
my_metadata->freed = true;
when you do the ++ in the metadata struct, it will jump by 16 (be we made it 16 bytes long)
char* new_meta_pointer = ((char*)my_metadata)++ --> this would only make it jump by 1, so wrong. Better to keep as a metadata pointer type. 

so:
void* payload_ptr = ++my_metadata // get me to the % in the above visual (aka start of the payload)
return (void*) my_metadata;

payload should start immediately after the metadata. 

int myarray[5];
int* starter = &myarray[0] = 0 // we know that ints have a size of 4. 
++starter --> same thing as start=&myarray[1] = 4



in free func:
metadata* temp = (metadata*) ptr;
temp--;
nsize = temp->size;










*/